
#ifndef __ComicMaker__h__
#define __ComicMaker__h__

#include "HTTPGet.h"
#include <time.h>
#include <fstream>

class ComicMaker
{
protected:

	struct DATE_TOKEN
	{
		std::string Name;
		int NumDaysAgo;
		std::string Value;
	};

	struct URL_TOKEN
	{
		std::string Name;
		std::string Domain;
		std::string Path;
		std::string ParseToken;
	};

	struct URL_TOKEN_LIST
	{
		bool UseList;
		URL_TOKEN First;
		URL_TOKEN Second;
		URL_TOKEN Third;
	};

	CListBox* theListbox;
	HTTPGet PageFetcher;

public:
	ComicMaker(CListBox* Listbox);
	~ComicMaker();

	bool Runner(void);

	bool CheckForUpdates(std::string &OutPage, time_t theTime);
	void ParseWebPage(const std::string &WebPage, std::string SearchString, std::string &ComicID);
	bool ReadInFile(const char *FileToRead, std::string &OutPage);
	void ParseSingleToken(std::string &OutPage, const char* Token, const char* NewVal);
	void ProcessADateBasedToken(std::string &OutPage, DATE_TOKEN& currentDateToken, const tm& today);
	void WipeToken(URL_TOKEN& theToken);
	void DownloadAToken(URL_TOKEN& currentURLToken, std::string& ComicID);
	std::string PickToken(const std::string& FirstID, const std::string& SecondID, const std::string& ThirdID);
	void ProcessAURLBasedToken(std::string &OutPage, URL_TOKEN_LIST& currentURLTokenList);
	void ParseTokens(std::string &OutPage, time_t theTime);
	void WriteOutFile(const std::string &OutPage);
	bool GetDateToken(std::ifstream &Reader, DATE_TOKEN &token, char* temp);
	bool GetURLTokenList(std::ifstream &Reader, URL_TOKEN_LIST &tokenlist, char* temp);
	bool GetOneURLToken(std::ifstream &Reader, URL_TOKEN &token, char* temp);
	bool CheckForUpdates(bool& iniUpdates, bool& progUpdates, bool& updaterUpdate,
		int& iniVersion, int& progVersion, int& UpdateVersion);
	void UpdateTheUpdater(const int iniVersion, const int progVersion, const int UpdateVersion);

	void WriteVersionFile(const int progVersion, const int iniVersion, const int UpdateVersion);

};

#endif